#  Assemblify-base pipeline
This project was carried out as part of a course entitled 'FAIR principles applied to genome assembly and annotation' in the Master 2 in Bioinformatics at the University of Rennes.  
The aim of the project is to create a genome assembly and annotation pipeline that complies with FAIR principles. 

This pipeline has been developed on the basis of a Nextflow (https://www.nextflow.io/docs/latest/index.html) pipeline already containing ready-to-use FastQC, MultiQC and hifiasme steps. It is available here: https://gitlab.com/ifb-elixirfr/training/workflows/nf_assemblify-base

# Compute requirements


Depending on the tools used, different resource configurations can be applied. Three are defined in the `ressources.config` file:

- « lowmem » : 2 cpus, 8.GB during 4 hour.
- « midmem » : 14 cpus, 24.GB during 8 hour.
- « highmem » : 14 cpus, 64.GB during 12 hour.

These configurations can be modified as required

# Usage

If you use the IFB Core Cluster you just need to clone this gitlab projet :

`git clone git@gitlab.com:Elisa.ce/nf_assemblify-base.git`

Then create a folder containing temporary results files, this will be the working directory of the pipeline at runtime :

`mkdir assemblify-tmp`

To lauch the pipeline you can running the `run_assembly.slurm` script :
sbatch run_assemblify.slurm

**Before you need to modify the line 15 and indicate the path of your work directory**


# Data

## Full data

|Study Accession|	Sample Accession|	Run Accession|	Scientific Name|	Library Construction Protocol|
|-------|-----------------|--------------|-------------|------------|
|PRJEB46283|	SAMEA7524530|	ERR6688549|	Dunaliella primolecta|	RNA PolyA|
|PRJEB46283|	SAMEA8100059|	ERR6688544|	Dunaliella primolecta|	Chromium genome|
|PRJEB46283	|SAMEA8100059	|ERR6688545	|Dunaliella primolecta|	Chromium genome|
|PRJEB46283	|SAMEA8100059	|ERR6688546	|Dunaliella primolecta|	Chromium genome|
|PRJEB46283	|SAMEA8100059	|ERR6688547	|Dunaliella primolecta	|Chromium genome|
|PRJEB46283	|SAMEA8100059	|ERR6688548	|Dunaliella primolecta	|Hi-C - Arima v2|
|PRJEB46283	|SAMEA8100059	|ERR6939244	|Dunaliella primolecta	|PacBio - HiFi|

Full data are available on Darwin Tree of Life Data Portal : https://portal.darwintreeoflife.org/data/root/details/Dunaliella%20primolecta


## Test data 
|Study Accession|	Sample Accession|	Run Accession|	Scientific Name|	Library Construction Protocol|
|-------|-----------------|--------------|-------------|------------|
|PRJEB46283	|SAMEA7524530	|ERR6688549	|Dunaliella primolecta	|RNA PolyA|
|PRJEB46283	|SAMEA8100059	|ERR6939244	|Dunaliella primolecta	|PacBio - HiFi|

To test the pipeline you can use the following data:

The previous PacBio and Illumina (RNA-seq) data have been reduced using 3 genome scaffolds in order to reduce data volumetry and computation time for each pipeline step to be developed.

Data are available on IFB Core Cluster :  `/shared/projects/2401_m2_bim/data/assemblify`. 

# Pipeline
![pipeline](pipeline_schema.png)

***Step 5, BRAKER3, has not yet been added to the pipeline.***
## FastQC

To control the quality of the sequencing of RNA-seq data we used FastQC (v0.11.9) (https://github.com/s-andrews/FastQC)

Docker image : quay.io/biocontainers/fastqc:0.11.9--hdfd78af_1

Input data :
- Illumina sequencing files - `.fastq.gz`

Output data :
- Web report -  `.html`
- Archive -  `.zip`


## MultiQC

MultiQC is used to aggregate and visualize quality control results from multiple bioinformatics analyses. We used the version 1.14. (https://github.com/MultiQC/MultiQC)

Docker image : quay.io/biocontainers/multiqc:1.14--pyhdfd78af_0

Input data :
- Archive from FastQC - `.zip`

Output data :
- Web report - `.html`


## Nanoplot

Nanoplot allows you to visualize the quality of nanopore sequencing data. It is ideally suited to PacBio data analysis, as both sequencing techniques produce long reads. We used the version 1.32.1. (https://github.com/wdecoster/NanoPlot)

Docker image : quay.io/biocontainers/nanoplot:1.32.1--py_0

Input data :
- PacBio sequencing files - `.fastq.gz`

Output data :
- Web report - `.html`
- Plot - `.png`
- Statistics - `.txt`

## Hifiasm

Hifiasm is designed for genome assembly from data generated by long-read sequencing technologies, such as those produced by the PacBio or Oxford Nanopore Technologies (ONT) platforms. We used the version 0.18.9. (https://github.com/chhylp123/hifiasm)

Docker image : quay.io/biocontainers/hifiasm:0.18.9--h5b5514e_0

Input data :
- PacBio sequencing files - `.fastq.gz`

Output data :
- Assembly sequences - `.fasta` (ignore hap1 and hap2 )
- Assembly graph - `.gfa`

## Busco

BUSCO is a bioinformatics tool used to assess the quality of assembled genomes by identifying the presence of conserved genes, also known as orthologs, which are thought to be present in a single copy in most genomes. We used the version 5.5.0. (https://gitlab.com/ezlab/busco)


Docker image : quay.io/biocontainers/busco:5.5.0--pyhdfd78af_0

Input data :
- Assembly sequences from Hifiasm - `.fasta`

Ouput data :
- Subfolders
- Statistics - `.tsv`

## Red

RED identifies and masks repeated sequences that can cause problems during genomic assembly and gene annotation. We used the version 2018.09.10. (https://github.com/rmhubley/RepeatMasker)

Docker image : quay.io/biocontainers/red:2018.09.10--h4ac6f70_2

Input data :
- Assembly sequences from Hifiasm - `.fasta`

Output data :
- Softmasked assembly sequences - `.msk`

## Hisat2

Hisat2 is tool mainly used to align RNA sequences from high-throughput sequencing to a reference genome. We used the version 2.2.1. (https://github.com/DaehwanKimLab/hisat2)

Docker image : quay.io/biocontainers/hisat2:2.2.1--h87f3376_5

Input data :
- Illumina sequencing files - `.fastq.gz`
- Softmasked assembly sequences from RED - `.msk`

Output data :
- Mapping file - `.sam`
- Genome index - `.ht2`

## Samtools

Samtools is used to convert SAM file to BAM file and index file. We used the version 1.6. (https://github.com/samtools/samtools)

Docker image : quay.io/biocontainers/samtools:1.6--hc3601fc_10

Input data :
- Mapping file - `.sam`

Output data :
- Binary mapping file - `.bam`
- Mapping file index - `.bai`

# Results organisation 

```
`-- assemblify
    |-- 00_pipeline_info
    |   |-- base.config
    |   `-- cmd
    |       |-- busco.cmd
    |       |-- fastqc_illumina_rnaseq_ERR6688549_1.subset.fastq.cmd
    |       |-- fastqc_illumina_rnaseq_ERR6688549_2.subset.fastq.cmd
    |       |-- hifiasm.cmd
    |       |-- hisat2.cmd
    |       |-- multiqc.cmd
    |       `-- samtools_illumina_rnaseq_ERR6688549_1.subset.cmd
    |-- 01_reports
    |   |-- dag.svg
    |   |-- report.html
    |   |-- timeline.html
    |   `-- trace.tsv
    `-- 02_results
        |-- 01a_fastqc
        |-- 01b_multiqc
        |-- 01c_nanoplot
        |-- 02a_hifiasm
        |-- 02b_busco
        |   `-- res.busco
        |       |-- logs
        |       |-- run_chlorophyta_odb10
        |       |   |-- busco_sequences
        |       |   |   |-- fragmented_busco_sequences
        |       |   |   |-- multi_copy_busco_sequences
        |       |   |   `-- single_copy_busco_sequences
        |       |   |-- full_table.tsv
        |       |   |-- hmmer_output
        |       |   |   |-- initial_run_results
        |       |   |   `-- rerun_results
        |       |   |-- metaeuk_output
        |       |   |   |-- combined_nucl_seqs.fas
        |       |   |   |-- combined_pred_proteins.fas
        |       |   |   |-- initial_results
        |       |   |   |-- refseq_db_rerun.faa
        |       |   |   `-- rerun_results
        |-- 03_red
        |   `-- masked
        |-- 04a_hisat2
        |-- 04b_samtools
        |-- 04c_multiqc
        `-- logs
            |-- busco
            |-- fastqc
            |-- hifiasm
            |-- hisat2
            |-- multiqc
            |-- multiqc_hisat2
            |-- nanoplot
            |-- red
            `-- samtools
```

# Licence

This project is licensed under CC BY 4.0. For more information you can read LICENSE.

# Feedback
If you notice any problems or have any requests, you can make them here : 
https://gitlab.com/Elisa.ce/nf_assemblify-base/-/issues

Otherwise you can contact us :

oceane.carpentier@etudiant.univ-rennes.fr

elisa.chenel@etudiant.univ-rennes.fr

# Improvement

The next step to add is BRAKER3 (https://github.com/Gaius-Augustus/BRAKER) for gene prediction.

# Authors

Elisa Chenel

Océane Carpentier

